def Prettyprint_Plan(actionlist):
    return [_prettyaction(x) for x in actionlist[1:]]

def Prettyprint_rule(RuleEvidence, Hypothesis_TruthValue, rule):
    actions_values_preconditions = rule[0]
    action = _prettyaction(actions_values_preconditions[0])
    precons = actions_values_preconditions[2:]
    print("<(", end="")
    print("vars=" + str(list(actions_values_preconditions[1])), end=", ")
    for i, x in enumerate(precons):
        print(f"{_prettyTriplet(x)}", end="")
        if i != len(precons)-1:
            print(f", ", end="")
    scoreInc = f"score+={rule[1][3][0]}"
    keys = f"vars={list(rule[1][3][1:])}"
    if action == "^up": #print actions with same width
        action += "   "
    if action == "^down" or action == "^left":
        action += " "
    print(",", action + str(")"), "=/> (" + keys + ", " + _prettyTriplet(rule[1]) + ", " + scoreInc + ")>.", Hypothesis_TruthValue(RuleEvidence[rule]))

def _prettyTriplet(triplet):
    (y, x, value) = triplet[:3]
    if y >= 0: y = " " + str(y)
    if x >= 0: x = " " + str(x)
    return "shape[" + str(x) + "," + str(y) + f" ]='{value}'"

def _prettyaction(action):
    return "^" + str(action).split("<function ")[1].split(" at")[0]
